-- =============================================
-- Author:		FID.Deny
-- Create date: 2015-05-06
-- Description:	Get Data For Change Over Report (DCLReport)
-- =============================================
CREATE PROCEDURE [dbo].[GetChangeOverData] 
	@DOCKCD VARCHAR(MAX),
	@REP_DATE VARCHAR(15),
	@CURR_DATE VARCHAR(15)

--	@TYPE VARCHAR(7) --current or next
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	DECLARE @DOCK_MAPPING INT
	DECLARE @PHYDOCK TABLE (DOCKCD VARCHAR(4))
	DECLARE @exROUTE VARCHAR(2) = '';

	SET @exROUTE = (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE FUNCTION_ID = '36002' AND SYSTEM_CD = 'CHANGEOVER')
	--DECLARE @DOCKTABLE TABLE (DOCKCD VARCHAR(4))


	SET @DOCK_MAPPING = (SELECT COUNT(1) FROM TB_M_PHYSICAL_DOCK_MAPPING A 
					WHERE A.LOGICAL_DOCKCD = @DOCKCD
					OR A.PHYSICAL_DOCKCD = @DOCKCD);

	IF (@DOCK_MAPPING > 0)	
		BEGIN
	
		INSERT INTO @PHYDOCK SELECT ISNULL(A.LOGICAL_DOCKCD,@DOCKCD) 
			FROM TB_M_PHYSICAL_DOCK_MAPPING A 
			WHERE A.LOGICAL_DOCKCD = @DOCKCD OR A.PHYSICAL_DOCKCD = @DOCKCD
	

		END
	
	INSERT INTO @PHYDOCK exec dbo.SplitString @DOCKCD, ';'

	--INSERT INTO @PHYDOCK SELECT @DOCKCD



	SELECT
		DISTINCT
		CONVERT(VARCHAR(10), a.RTEDATE, 121) AS RTEDATE,
		a.RTEGRPCD, 
		a.RUNSEQ,
		a.SUPPCD, 
		a.RCVCOMPDOCKCD, 
		a.ORDDATE, 
		a.ORDSEQ, 
		a.SUPPPLANTCD,
		a.ORDDATE + RIGHT('00'+a.ORDSEQ, 2) AS ENDOFORDER,
		--a.UNLOADSTRTIME,
		CAST(CONVERT(VARCHAR(10), a.RTEDATE, 121) +' '+ a.UNLOADENDTIME AS datetime) AS UNLOADSTRTIME,
		 
		a.UNLOADENDTIME,
		b.LOGPARTNERCD,
		'current' AS [status]
	INTO #temp
	FROM  tb_r_dcl_tlms_order_assignment a, TB_R_DCL_TLMS_DRIVER_DATA b
	WHERE a.RTEDATE = b.RTEDATE and a.RUNSEQ = b.RUNSEQ and a.RTEGRPCD = b.RTEGRPCD
			AND CAST(a.RTEDATE AS DATE) = CAST(@CURR_DATE AS DATE)--dateadd(day, -1,CAST(@REP_DATE AS DATE))
			--AND a.RTEGRPCD in ('DN06', 'DN05', 'DN01')
			AND a.RCVCOMPDOCKCD in (SELECT DISTINCT DOCKCD FROM @PHYDOCK)
			AND a.RTEGRPCD NOT LIKE (@exROUTE+'%')

	INSERT INTO #temp
	SELECT
		DISTINCT
		CONVERT(VARCHAR(10), a.RTEDATE, 121) AS RTEDATE,
		a.RTEGRPCD, 
		a.RUNSEQ,
		a.SUPPCD, 
		a.RCVCOMPDOCKCD, 
		a.ORDDATE, 
		a.ORDSEQ, 
		a.SUPPPLANTCD,
		a.ORDDATE + RIGHT('00'+a.ORDSEQ, 2) AS ENDOFORDER,
		--a.UNLOADSTRTIME, 
		CAST(CONVERT(VARCHAR(10), a.RTEDATE, 121) +' '+ a.UNLOADENDTIME AS datetime) AS UNLOADSTRTIME,
		a.UNLOADENDTIME,
		b.LOGPARTNERCD,
		'next' AS [status]
	FROM  tb_r_dcl_tlms_order_assignment a, TB_R_DCL_TLMS_DRIVER_DATA b
	WHERE a.RTEDATE = b.RTEDATE and a.RUNSEQ = b.RUNSEQ and a.RTEGRPCD = b.RTEGRPCD
			AND CAST(a.RTEDATE AS DATE) = CAST(@REP_DATE AS DATE)
			--AND a.RTEGRPCD in ('DN06', 'DN05', 'DN01')
			AND a.RCVCOMPDOCKCD in (SELECT DISTINCT DOCKCD FROM @PHYDOCK)
			AND a.RTEGRPCD NOT LIKE (@exROUTE+'%')

	select * from #temp

	 drop table #temp

END

